/** 
	Copyright 2009 Bill Horne

	This file is part of the Poincare program for photographic
	tiling of the Poincare disk.

    Poincare is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Poincare is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Poincare.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef _AffineTransform_h_
#define _AffineTransform_h_

#include "Point.h"

class AffineTransform{
public:
	AffineTransform();
	
	Point transform(Point p);
	void translate(double x, double y);
	void rotate(double theta);
	void scale(double s);

private:
	double _a00;
	double _a01;
	double _a02;
	double _a10;
	double _a11;
	double _a12;
};


#endif _AffineTransform_h_