/** 
	Copyright 2009 Bill Horne

	This file is part of the Poincare program for photographic
	tiling of the Poincare disk.

    Poincare is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Poincare is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Poincare.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef _Circle_h_
#define _Circle_h_

#include <cmath>
#include "Point.h"

class Circle {
public:
	Circle();
	Circle(Point p, double r);

	double radius() { return _r; }
	Point center() { return _p; }

	bool insideOrOn(Point p);
	Point invert(Point p);

private:
	Point _p;
	double _r;
};

Circle createEdgeCircle(int p, int q);

const static double PI = 4.0*atan(1.0);

#endif // _Circle_h_

