/** 
	Copyright 2009 Bill Horne

	This file is part of the Poincare program for photographic
	tiling of the Poincare disk.

    Poincare is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Poincare is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Poincare.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef _FundamentalRegion_h_
#define _FundamentalRegion_h_

#include "Circle.h"
#include "Point.h"

class FundamentalRegion
{
public:
	FundamentalRegion(int p, int q);
	bool inside(Point p);
	bool reversePixelLookup(Point a, int maxIterations, Point *out, bool *parity);

private:
	Circle _edge;
	double _m;  // tan(PI/p) - slope of line at PI/p
	double _c;	// cos(PI/p)
	double _s;  // sin(PI/P)
	int _p;
};


#endif // _FundamentalRegion_h_
