/** 
	Copyright 2009 Bill Horne

	This file is part of the Poincare program for photographic
	tiling of the Poincare disk.

    Poincare is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Poincare is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Poincare.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef _Parameters_h_
#define _Parameters_h_

class Parameters {
public:
	Parameters(char *filename);

	void print();

public:
	// Common Parameters
	int p;
	int q;
	int jpegQuality;
	char *infile;
	char *outfile;
	char *action;
	bool upper;
	double px;
	double py;
	double rx;
	double ry;
	
	// FundamentalRegion Parameters
	char *maskColor;

	// Render Parameters
	int renderedSize;
	int borderSize;
	int supersamplingRate;
	double perturbationFactor;
	char *outOfBoundsColor;
	char *unreachableColor;
	char *nonSourceColor;
	int maxIterations;
	bool negate;
};

#endif //_Parameters_h_